package sun.security.krb5.internal;

import java.security.AccessController;
import sun.security.action.GetPropertyAction;
import sun.security.krb5.internal.rcache.MemoryCache;
import sun.security.krb5.internal.rcache.DflCache;
import sun.security.krb5.internal.rcache.AuthTimeWithHash;

public abstract class ReplayCache
{
    public ReplayCache() {
    }
    
    public static ReplayCache getInstance(String s) {
        if (s == null) {
            return new MemoryCache();
        }
        if (s.equals("dfl") || s.startsWith("dfl:")) {
            return new DflCache(s);
        }
        if (s.equals("none")) {
            return new ReplayCache() {
                @Override
                public void checkAndStore(KerberosTime kerberosTime, AuthTimeWithHash authTimeWithHash) throws KrbApErrException {
                }
            };
        }
        throw new IllegalArgumentException("Unknown type: " + s);
    }
    
    public static ReplayCache getInstance() {
        return getInstance((String)AccessController.doPrivileged(new GetPropertyAction("sun.security.krb5.rcache")));
    }
    
    public abstract void checkAndStore(KerberosTime p0, AuthTimeWithHash p1) throws KrbApErrException;
}
